export declare type DevDependencies = Record<string, string>;
export declare function isPrebuildifyNativeModule(devDependencies: DevDependencies): boolean;
/**
 * Runs the `uname` command and returns the trimmed output.
 *
 * Copied from `@electron/get`.
 */
export declare function uname(): string;
export declare type ConfigVariables = {
    arm_version?: string;
};
/**
 * Generates an architecture name that would be used in an Electron or Node.js
 * download file name.
 *
 * Copied from `@electron/get`.
 */
export declare function getNodeArch(arch: string, configVariables: ConfigVariables): string;
export declare function determineNativePrebuildArch(arch: string): string;
/**
 * The extension of `prebuildify`-generated native modules, after the last `.`. This value differs
 * based on whether the target arch is ARM-based.
 */
export declare function determineNativePrebuildExtension(arch: string): string;
export declare function findPrebuildifyModule(modulePath: string, platform: string, arch: string, electronVersion: string, abi: string, devDependencies: DevDependencies): Promise<boolean>;
