"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getElectronNodeAPIVersion = exports.ensureElectronSupportsNodeAPI = void 0;
const node_api_version_1 = require("node-api-version");
function ensureElectronSupportsNodeAPI(moduleName, electronVersion) {
    getElectronNodeAPIVersion(moduleName, electronVersion);
}
exports.ensureElectronSupportsNodeAPI = ensureElectronSupportsNodeAPI;
function getElectronNodeAPIVersion(moduleName, electronVersion) {
    const electronNapiVersion = node_api_version_1.fromElectronVersion(electronVersion);
    if (!electronNapiVersion) {
        throw new Error(`Native module '${moduleName}' requires Node-API but Electron v${electronVersion} does not support Node-API`);
    }
    return electronNapiVersion;
}
exports.getElectronNodeAPIVersion = getElectronNodeAPIVersion;
//# sourceMappingURL=node-api.js.map